﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace ApiScanner.Core
{
    public sealed class FileSystemArtifact: Artifact
    {
        public IEnumerable<string> DllsFound { get; private set; }
        public string FileName { get; private set; }

        public FileSystemArtifact(string fileName, IEnumerable<string> dllsFound)
        {
            if (fileName == null) throw new ArgumentNullException("fileName");
            if (dllsFound == null) throw new ArgumentNullException("dllsFound");
            DllsFound = dllsFound.ToArray();
            FileName = fileName;
        }
    }
}