﻿using System;

namespace ApiScanner.Core
{
    /// <summary>
    /// Class representing the Schema Collection Reference (SCR). Denoted in Store schema as 
    /// "urn:schemas-microsoft-com:exch-data:schema-collection-ref".
    /// The SCR property is set on folders (and items!) to indicate where schema, 
    /// wss forms and yes, store events are registered to handle actions on objects.
    /// </summary>
    /// <remarks>
    /// Not using this anywhere yet
    /// </remarks>
    internal class SchemaCollectionRef
    {
        /// <summary>
        /// Path of item on which SCR is set
        /// </summary>
        public Uri Path;

        /// <summary>
        /// Value of SCR.  Should contain schema, forms, events - and be used to dump events.
        /// </summary>
        public Uri Value;
    }
}